import terrylib.*;

class Main {
	var bagX:Float;
	var bagY:Float;

	var bagWidth:Int;
	var bagHeight:Int;

	var starX:Array<Float>;
	var starY:Array<Float>;

	var starWidth:Array<Int>;
	var starHeight:Array<Int>;
	var starState:Array<Int>; //0 in bag, 1 holding, 2 placed

	var state:Int=0;

	// new() is a special function that is called on startup.
	function new() {

		starX = new	Array<Float>();
		starY = new	Array<Float>();
		starWidth = new	Array<Int>();
		starHeight = new Array<Int>();
		starState = new Array<Int>();

		Gfx.loadimage("starbag");	
		bagWidth = Gfx.imagewidth("starbag");
		bagHeight = Gfx.imageheight("starbag");

		for (i in 0...35){
			var s:String="star"+i;
			Gfx.loadimage(s);
			starWidth.push(Gfx.imagewidth(s));
			starHeight.push(Gfx.imagewidth(s));
		}

		bagX=Random.int(3,Gfx.screenwidth-bagWidth-6);
		bagY=Random.int(3,Gfx.screenheight-bagHeight-6);
		for (i in 0...35){
			var s:String="star"+i;
			var sw = starWidth[i];
			var sh = starHeight[i];
			var x = Random.int(5,bagWidth-sw-15);
			var y = Random.int(40,bagHeight-sh-5);
			starX.push(x);
			starY.push(y);
			starState.push(0);
		}

	}

	var lastMouseX=0;
	var lastMouseY=0;

	function overlaps(x:Float,y:Float,bx:Float,by:Float,bw:Float,bh:Float):Bool{
		return 
			(x>=bx) &&
			(x<=bx+bw-1) &&
			(y>=by) &&
			(y<=by+bh-1);
	}

	//-1 hit nothing,0...34 hit star, 100 hit bag lower, 101, hit bag upper
  function mouseCollision():Int{
  	var mx = Mouse.x;
  	var my = Mouse.y;
  	if (overlaps(mx,my,bagX,bagY,bagWidth,43)){
  		trace("clicked bag top");
  		return 101;
  	} else if  (overlaps(mx,my,bagX,bagY+43,bagWidth,bagHeight-43)){
  		trace("clicked bag bottom");
  		return 100;
  	} /*
  	for (i in 0...35)  {
  		var sx=starX[i];
  		var sy=starY[i];
  		var sw=starWidth[i];
  		var sh=starHeight[i];
  		if (overlaps(mx,my,sx,sy,sw,sh)){
  			var s = "star"+i;
  			var dx=mx-sx;
  			var dy=my-sy;
  			var col =Gfx.getspritepixel(dx,dy,s);
  			trace(col);
  			if ((col&0xff000000)>0){
  				trace("found "+i);
  				return i;
  			}
  		}
  	}*/
  	trace("nothing found");
  	return -1;
  }

  var clickTarget:Int=-1;//-1 no target,1...35 items, 100 bag
  var dragdx:Float;
  var dragdy:Float;
	var placed:Int=0;
	function drawGame(){
		trace("drawing");
		if (state==1){
	  		Gfx.cls(0xFFDDDDD0);
	  	} else {
	  		Gfx.cls(0xff000000);
	  	}

		for (i in 0...35){
			if (starState[i]==0){
				Gfx.drawimage(bagX+starX[i],bagY+starY[i],"star"+i);
			} else {
				Gfx.drawimage(starX[i],starY[i],"star"+i);
			}
		}
		if (state==1){
	  		Gfx.drawimage(bagX,bagY,"starbag");
	  	}
	  	if (clickTarget>=0&&clickTarget<50){
	  		trace("redrawing");
	  		Gfx.drawimage(starX[clickTarget],starY[clickTarget],"star"+clickTarget);
	  	}
	}

	var lines1:Array<String> = [
		"Light pollution means we never see the stars.",
		"For the first time in my life, I am siezed by a romantic impulse.",
		"To most people now, the night sky is an empty void.",
		"In case he should come back to my flat,",
		"I bought a pack of glow-in-the-dark stars.",
		"We will lie together on the floor of the living room\nand look up and talk about the stars.\n \n"
	];

	var lines2:Array<String> = [
		"It was great hanging out this evening.",
		"He said.",
		"We're going to become good friends, I just know it.",
		"He said.",
		"And I was happy to hear it.",
		"If someone's worth loving they're worth befriending."
	];
	var stateProgress = 0;
  function update() {
		
	if (state==0){
		Gfx.cls(0xff000000);
		if (Mouse.leftclick()){
			stateProgress++;
			if (stateProgress>=lines1.length){
				state++;
				stateProgress = 0;
				return;
			}
		}
		Text.display(0,Gfx.screenheight/2-15,lines1[stateProgress]);		
		return;
	} else if (state==2){
		Gfx.cls(0xff000000);
		if (Mouse.leftclick()){
			stateProgress++;
			if (stateProgress>=lines2.length){
				state++;
				return;
			}
		}
		Text.display(0,Gfx.screenheight/2-15,lines2[stateProgress]);		
		return;
	} else {
	  	var mx=Mouse.x;
	  	var my=Mouse.y;

			if (clickTarget>=0&&clickTarget<50){
				starX[clickTarget]=mx+dragdx;
				starY[clickTarget]=my+dragdy;
				starState[clickTarget]=1;
				if (Mouse.leftclick()){
					clickTarget=-1;
					drawGame();
					trace(state);
					if (placed==35){
						state++;
					}
					return;
				}
			} else if (clickTarget>=100){
				bagX=mx+dragdx;
				bagY=my+dragdy;
				if (Mouse.leftclick()){
					clickTarget=-1;
					drawGame();
					return;
				}
			}
			drawGame();
			
			if (Mouse.leftclick()&&clickTarget<0){
				trace("click");
				var target = mouseCollision();
				trace("col ="+target);
				if (target==101){
					clickTarget=100;
					dragdx=bagX-mx;
					dragdy=bagY-my;	
				} else if (target==100){
					clickTarget=34-placed;
					dragdx=-starWidth[clickTarget]/2;
					dragdy=-starHeight[clickTarget]/2;
					placed++;
				}
				/*
				if (target>=0&& target<40){
					clickTarget=target;
					var s = "star"+target;
					dragdx=mx-starX[target];
					dragdy=my-starY[target];				
				}*/
			}
		}
	}
}